chiark / gitweb /
regress: Break out some functions from r1test into a new file
[adns.git] / regress / r1test
index a15f07172de34ee2b523571d44c8656da325f1f8..74d7df2a9ce35b3ce63f319633d2a86f69141911 100755 (executable)
@@ -1,39 +1,99 @@
 #!/bin/sh
 # usage: r1test <testcasename>
+# test execution script, for running one test
+#
+#  This file is part of adns, which is
+#    Copyright (C) 1997-2000,2003,2006,2014-2016,2020  Ian Jackson
+#    Copyright (C) 2014  Mark Wooding
+#    Copyright (C) 1999-2000,2003,2006  Tony Finch
+#    Copyright (C) 1991 Massachusetts Institute of Technology
+#  (See the file INSTALL for full details.)
+#  
+#  This program is free software; you can redistribute it and/or modify
+#  it under the terms of the GNU General Public License as published by
+#  the Free Software Foundation; either version 3, or (at your option)
+#  any later version.
+#  
+#  This program is distributed in the hope that it will be useful,
+#  but WITHOUT ANY WARRANTY; without even the implied warranty of
+#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#  GNU General Public License for more details.
+#  
+#  You should have received a copy of the GNU General Public License
+#  along with this program; if not, write to the Free Software Foundation.
 
 set -e
-case="case-$1"
+: ${srcdir=.}
+. "$srcdir"/shlib
+mrc=1
+trap 'exit $mrc' 0
 
-exec <"$case.sys"
-read initfile
-read queryargs
+casename="$1"
 
-initstring="`cat init-$initfile.text`"
+playback_prepare
 
-set +e
-ADNS_TEST_REPORT_FD=3 3>>"$case.report-o" >"$case.stdout-o" 2>"$case.stderr-o" \
- ./hplayback "/$initstring" $queryargs
-rc=$?
-set -e
+rm -f $ocase.*
+
+EF_DISABLE_BANNER=1
+export EF_DISABLE_BANNER
+
+if test -e "$case.in"
+then
+       exec <"$case.in"
+else
+       exec </dev/null
+fi
 
-if test $rc != 0
+if test ! -e $playback
 then
-       egrep . -- "$case.report-o" "$case.stdout-o" "$case.stderr-o"
-       echo >&2 "FAILED $case - EXIT STATUS $rc"
-       exit 2
+       printf "SKIPPED-$casename "
+       mrc=5
+       exit
 fi
 
-for part in stdout stderr
+playback_execute_callback () {
+       set +e
+       ADNS_TEST_REPORT_FD=3 ADNS_TEST_IN_FD=4 \
+        3>>"$ocase.report" 4<&4 >"$ocase.out" 2>"$ocase.err" \
+        $ADNS_TEST_DEBUG $playback "$@"
+       rc=$?
+       set -e
+}
+playback_execute
+
+if [ "$rc" = 5 ]
+then
+       printf "SKIPPED-$casename "
+       mrc=5
+       exit
+fi
+
+echo "rc=$rc" >>$ocase.out
+
+failed=false
+for part in err out
 do
-       if diff -- "$case.$part" "$case.$part-o"
+       if diff -u -- "$case.$part" "$ocase.$part"
        then
                :
        else
-               echo >&2 "FAILED $case - WRONG OUTPUT"
-               exit 2
+               failwhy="$failwhy WRONG OUTPUT"
        fi
 done
 
-echo -n " $case "
+cat <&4 >"$ocase.leftover"
+if egrep . /dev/null "$ocase.leftover"
+then
+       failwhy="$failwhy EXITED EARLY"
+fi
+
+if [ "x$failwhy" != x ]
+then
+       scremain="`wc -l <\"$ocase.leftover\"`"
+       echo >&2 "FAILED $case -$failwhy - lines of syscall remaining $scremain"
+       mrc=2
+       exit
+fi
 
-exit 0
+printf "$casename "
+mrc=0